Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.functions
Class FormatNumber2

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.FunctionCall
              net.sf.saxon.functions.SystemFunction
                  net.sf.saxon.functions.FormatNumber2

All Implemented Interfaces:
  Serializable, SourceLocator, Container, EvaluableItem, SequenceIterable, XSLTFunction, InstructionInfoProvider

    public class FormatNumber2

extends SystemFunction
implements XSLTFunction

XSLT 2.0 implementation of format-number() function - removes the dependence on the JDK.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`FormatNumber2()`

Method Summary
`static BigDecimal` | `adjustToDecimal(double value, int precision)` Convert a double to a BigDecimal.
`void` | `checkArguments(StaticContext env)` Method called during static type checking
`String` | `evaluateAsString(XPathContext context)` Evaluate in a context where a string is wanted
`Item` | `evaluateItem(XPathContext c)` Evaluate in a general context
`void` | `fixup(DecimalSymbols dfs)` Fixup: this is a callback from the DecimalFormatManager used once the xsl:decimal-format element is identified
`Expression` | `preEvaluate(StaticContext env)` preEvaluate: this method suppresses compile-time evaluation by doing nothing.

Methods inherited from class net.sf.saxon.functions.SystemFunction
`computeCardinality, computeSpecialProperties, display, getDetails, getErrorCodeForTypeErrors, getItemType, main, makeSystemFunction, optimize, setDetails`

Methods inherited from class net.sf.saxon.expr.FunctionCall
`getArguments, getDisplayName, getFunctionNameCode, getNumberOfArguments, iterateSubExpressions, promote, replaceSubExpression, setArguments, setFunctionNameCode, simplify, typeCheck`

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, effectiveBooleanValue, getCardinality, getColumnNumber, getContainingProcedure, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getInstructionInfo, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, iterate, markTailFunctionCalls, process, resetStaticProperties, setLocationId, setParentExpression, setParentExpression, suppressValidation`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### FormatNumber2

    public FormatNumber2()

Method Detail

### checkArguments

    public void checkArguments(StaticContext env)
                        throws XPathException

  Description copied from class: `SystemFunction`
  Method called during static type checking

  Overrides:
    `checkArguments` in class `SystemFunction`
  Throws:
    `XPathException`

### fixup

    public void fixup(DecimalSymbols dfs)

  Fixup: this is a callback from the DecimalFormatManager used once the xsl:decimal-format element is identified

### preEvaluate

    public Expression preEvaluate(StaticContext env)
                           throws XPathException

  preEvaluate: this method suppresses compile-time evaluation by doing nothing. We can't evaluate early because we don't have access to the DecimalFormatManager.

  Overrides:
    `preEvaluate` in class `FunctionCall`
  Throws:
    `XPathException`

### evaluateAsString

    public String evaluateAsString(XPathContext context)
                            throws XPathException

  Evaluate in a context where a string is wanted

  Overrides:
    `evaluateAsString` in class `Expression`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the value of the expression, evaluated in the current context. The expression must return a string or (); if the value of the expression is (), this method returns "".
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### evaluateItem

    public Item evaluateItem(XPathContext c)
                      throws XPathException

  Evaluate in a general context

  Specified by:
    `evaluateItem` in interface `EvaluableItem`
  Overrides:
    `evaluateItem` in class `Expression`
  Parameters:
    `c` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### adjustToDecimal

    public static BigDecimal adjustToDecimal(double value,
                                             int precision)

  Convert a double to a BigDecimal. In general there will be several BigDecimal values that are equal to the supplied value, and the one we want to choose is the one with fewest non-zero digits. The algorithm used is rather pragmatic: look for a string of zeroes or nines, try rounding the number down or up as approriate, then convert the adjusted value to a double to see if it's equal to the original: if not, use the original value unchanged.

  Parameters:
    `value` - the double to be converted
    `precision` - 2 for a double, 1 for a float
  Returns:
    the result of conversion to a double

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.